/* File:        ngs/model/Flowcell.java
 * Copyright:   GBIC 2000-2,013, all rights reserved
 * Date:        August 21, 2013
 * Template:	JpaMapperGen.java.ftl
 * generator:   org.molgenis.generators.db.JpaMapperGen 4.0.0-testing
 *
 * Jpa Entity Mapper, helper to add, delete and update entities
 * 
 * THIS FILE HAS BEEN GENERATED, PLEASE DO NOT EDIT!
 */

package org.molgenis.omx.ngs.db;

@edu.umd.cs.findbugs.annotations.SuppressWarnings(value = "DLS_DEAD_LOCAL_STORE", justification = "Too much template code required to prevent warnings")
public class FlowcellJpaMapper extends org.molgenis.framework.db.jpa.AbstractJpaMapper<org.molgenis.omx.ngs.Flowcell>
{
	private final static org.apache.log4j.Logger log = org.apache.log4j.Logger.getLogger(FlowcellJpaMapper.class);

	public FlowcellJpaMapper(org.molgenis.framework.db.Database db) 
	{
		super(db);
	}
	
	@Override
	public String createFindSqlInclRules(org.molgenis.framework.db.QueryRule[] rules) throws org.molgenis.framework.db.DatabaseException
	{
		return "SELECT Flowcell.id"
			+", Flowcell.FlowcellDirection"
			+", Flowcell.FlowcellName"
			+", Flowcell.Machine"
			+", Flowcell.Run"
			+", Flowcell.RunDate"
			//parent is SimpleTree(name='Machine')
			+", xref_Machine.MachineName AS Machine_MachineName"
			+" FROM Flowcell "

			
			//label for Machine=MachineName
//path==Machine. type==xref.
//path==Machine_MachineName. type==string.
//in if path.value.type != "xref" && !pathlist?seq_contains(path.getParent().name)
		   	+" LEFT JOIN Machine AS xref_Machine " 
			+" ON xref_Machine.id = Flowcell.Machine"
;
	}	

	/** This method first saves the objects that are being refered to by entity, 
	then the entity itself and 
	finally the objects that refer to this object*/
    public void create(org.molgenis.omx.ngs.Flowcell entity) throws org.molgenis.framework.db.DatabaseException {
        try {


			//check if the object refered by 'Machine' is known in the databse
			if(entity.getMachine() != null)
			{
				//if object has been added as xref, but not yet stored (has no id) -> add the refered object
				if(entity.getMachine().getIdValue() == null)
					new org.molgenis.omx.ngs.db.MachineJpaMapper(getDatabase()).create(entity.getMachine());
				//if object has id (so is stored) but not in this em -> retrieve proper reference reference
				else if (!getEntityManager().contains(entity.getMachine()) && entity.getMachine().getIdValue() != null)
					entity.setMachine(getEntityManager().getReference(org.molgenis.omx.ngs.Machine.class, entity.getMachine().getIdValue()));
			} else { //object is reference by xref	
				if(entity.getMachine_Id() != null) {
					entity.setMachine((org.molgenis.omx.ngs.Machine)getEntityManager().find(org.molgenis.omx.ngs.Machine.class, entity.getMachine_Id()));
				}
			}

			//prevents uncontrolled recursion call of create (stack overflow)
          
          if(entity.getIdValue() != null) {
            entity = getEntityManager().merge(entity);            
          } else {
            getEntityManager().persist(entity);
          }
//inverse association relation

        } catch (Exception ex) {
            try {
				getEntityManager().getTransaction().rollback();
            } catch (Exception re) {
                throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: "+re.getMessage());
            }
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
    }

	public void destroy(org.molgenis.omx.ngs.Flowcell flowcell) throws org.molgenis.framework.db.DatabaseException {
		try {
			try {
				flowcell = getEntityManager().getReference(org.molgenis.omx.ngs.Flowcell.class, flowcell.getIdValue());
			} catch (javax.persistence.EntityNotFoundException enfe) {
				throw new org.molgenis.framework.db.DatabaseException("The flowcell with id " + flowcell.getIdField().toString() + " no longer exists: " + enfe.getMessage());
			}

			getEntityManager().remove(flowcell);
		} catch (Exception ex) {
			try {
				getEntityManager().getTransaction().rollback();
			} catch (Exception re) {
				throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: "+re.getMessage());
			}
			throw new org.molgenis.framework.db.DatabaseException(ex);
		} 
	}


	public void edit(org.molgenis.omx.ngs.Flowcell flowcell) throws org.molgenis.framework.db.DatabaseException {
		try {





			//1
			org.molgenis.omx.ngs.Machine machineNew = flowcell.getMachine();

			if (machineNew == null) { //object is reference by xref		
                            if(flowcell.getMachine_Id() != null) {
                                flowcell.setMachine((org.molgenis.omx.ngs.Machine)getEntityManager().find(org.molgenis.omx.ngs.Machine.class, flowcell.getMachine_Id()));
                            }
			}


			if(!getEntityManager().contains(flowcell)) {
				flowcell = getEntityManager().merge(flowcell);
			}
			

		} catch (Exception ex) {
			try {
				getEntityManager().getTransaction().rollback();
			} catch (Exception re) {
				throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: " + re.getMessage());
			}
			throw new org.molgenis.framework.db.DatabaseException(ex);
		} 
	}

	@Override
	public int executeAdd(java.util.List<? extends org.molgenis.omx.ngs.Flowcell> entities) throws org.molgenis.framework.db.DatabaseException
	{	
		int count = 0;
		
		try 
		{
			for (org.molgenis.omx.ngs.Flowcell flowcell : entities) 
			{
				create(flowcell);
				++count;
			}
		}
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
		return count;
	}

	@Override
	public int executeUpdate(java.util.List<? extends org.molgenis.omx.ngs.Flowcell> entities) throws org.molgenis.framework.db.DatabaseException
	{
		int count = 0;

		try
		{
			for (org.molgenis.omx.ngs.Flowcell flowcell : entities) 
			{
				edit(flowcell);
				++count;
			} 
			return count;
		}
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }		
	}

	@Override
	public int executeRemove(java.util.List<? extends org.molgenis.omx.ngs.Flowcell> entities) throws org.molgenis.framework.db.DatabaseException
	{
		int count = 0;		
		try 
		{
			for (org.molgenis.omx.ngs.Flowcell flowcell : entities) 
			{
				destroy(flowcell);
				++count;
			}
		} 
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
		return count;
	}
	
	@Override
	public String getTableFieldName(String fieldName)
	{
		if("id".equalsIgnoreCase(fieldName)) return "id";
		if("Flowcell_id".equalsIgnoreCase(fieldName)) return "id";
		if("FlowcellDirection".equalsIgnoreCase(fieldName)) return "FlowcellDirection";
		if("Flowcell_FlowcellDirection".equalsIgnoreCase(fieldName)) return "FlowcellDirection";
		if("FlowcellName".equalsIgnoreCase(fieldName)) return "FlowcellName";
		if("Flowcell_FlowcellName".equalsIgnoreCase(fieldName)) return "FlowcellName";
		if("Machine".equalsIgnoreCase(fieldName)) return "Machine";
		if("Flowcell_Machine".equalsIgnoreCase(fieldName)) return "Machine";
		if("Run".equalsIgnoreCase(fieldName)) return "Run";
		if("Flowcell_Run".equalsIgnoreCase(fieldName)) return "Run";
		if("RunDate".equalsIgnoreCase(fieldName)) return "RunDate";
		if("Flowcell_RunDate".equalsIgnoreCase(fieldName)) return "RunDate";
		if("Machine_id".equalsIgnoreCase(fieldName)) return "Machine";
		if("Flowcell_Machine_id".equalsIgnoreCase(fieldName)) return "Machine";
		if("Machine_MachineName".equalsIgnoreCase(fieldName)) return "Machine.MachineName";	
		if("Flowcell_Machine_MachineName".equalsIgnoreCase(fieldName)) return "Machine.MachineName";
		return fieldName;
	}
	
	/**
	 * Return EMPTY list of given allocated size
	 *
	 * @param i initial capacity of returned EMPTY list
	 * @return an EMPTY list with initial capacity given by size
	 */
	@Override
	public java.util.List<org.molgenis.omx.ngs.Flowcell> createList(int size)
	{
		return new java.util.ArrayList<org.molgenis.omx.ngs.Flowcell>(size);
	}			

	@Override
	public org.molgenis.omx.ngs.Flowcell create()
	{
		return new org.molgenis.omx.ngs.Flowcell();
	}

	@Override
	//Resolve
	public void resolveForeignKeys(java.util.List<org.molgenis.omx.ngs.Flowcell> entities)  throws org.molgenis.framework.db.DatabaseException, java.text.ParseException
	{
		//create foreign key map for field 'machine' to machine.id using MachineName)	
		//we will use a hash of the values to ensure that entities are only queried once	
		final java.util.Map<String, org.molgenis.framework.db.QueryRule> machineRules = new java.util.LinkedHashMap<String, org.molgenis.framework.db.QueryRule>();
		//create all query rules	
		for(org.molgenis.omx.ngs.Flowcell object: entities)
		{
			//create xref/mref rule filtering Machine on the label MachineName
			if(object.getMachine_Id() == null && object.getMachine_MachineName() != null)
			{
				Object label = object.getMachine_MachineName();
				{
					org.molgenis.framework.db.QueryRule xrefFilter = new org.molgenis.framework.db.QueryRule("MachineName", org.molgenis.framework.db.QueryRule.Operator.EQUALS, label.toString());
					
					if(label != null && !machineRules.containsKey(label))
					{
						machineRules.put(""+label, xrefFilter);
						machineRules.put(""+label+"_OR_", new org.molgenis.framework.db.QueryRule(org.molgenis.framework.db.QueryRule.Operator.OR));
					}
				}
			}		
		}

		//resolve foreign key field 'machine' to machine.id using MachineName)
		final java.util.Map<String,Integer> machine_Labels_to_IdMap = new java.util.TreeMap<String,Integer>();
		if(machineRules.size() > 0)
		{		
		
			java.util.List<org.molgenis.omx.ngs.Machine> machineList = null;
			try
			{
				machineList = getDatabase().find(org.molgenis.omx.ngs.Machine.class, machineRules.values().toArray(new org.molgenis.framework.db.QueryRule[machineRules.values().size()]));
			}
			catch(Exception e)
			{
				// something went wrong while querying for this entities' name field
				// we assume it has no such field, which should have been checked earlier ofcourse
				// regardless, just quit the function now
				throw new org.molgenis.framework.db.DatabaseException(e);
			}
		
			for(org.molgenis.omx.ngs.Machine xref :  machineList)
			{
				String key = "";
				key += 	xref.getMachineName();
				
				machine_Labels_to_IdMap.put(key, xref.getId());
			}
		}

		//update objects with the keys
		for(int i = 0; i < entities.size(); i++)
		{
			org.molgenis.omx.ngs.Flowcell object = entities.get(i);		
			//update object using label fields MachineName
			if(object.getMachine_Id() == null )
			{
					String key = "";
					if(object.getMachine_MachineName() != null)
						key += 	object.getMachine_MachineName();
					
					if(!"".equals(key) && machine_Labels_to_IdMap.get(key) == null) 
					{
						throw new org.molgenis.framework.db.DatabaseException("Machine_MachineName cannot be resolved: unknown xref='"+key+"'");
					}
					else
					{
						object.setMachine_Id(machine_Labels_to_IdMap.get(key));
					}
			}
						
		}
	}	
	
	@Override
	public org.molgenis.fieldtypes.FieldType getFieldType(String fieldName)
	{
			if("id".equalsIgnoreCase(fieldName) || "flowcell.id".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.IntField();
			if("flowcellDirection".equalsIgnoreCase(fieldName) || "flowcell.flowcellDirection".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.EnumField();
			if("flowcellName".equalsIgnoreCase(fieldName) || "flowcell.flowcellName".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.StringField();
			if("machine".equalsIgnoreCase(fieldName) || "flowcell.machine".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.XrefField();
			if("run".equalsIgnoreCase(fieldName) || "flowcell.run".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.StringField();
			if("runDate".equalsIgnoreCase(fieldName) || "flowcell.runDate".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.DatetimeField();
		return null;
	}		
	@Override
	public void prepareFileAttachements(java.util.List<org.molgenis.omx.ngs.Flowcell> entities, java.io.File baseDir) throws java.io.IOException
	{
	}

	@Override
	public boolean saveFileAttachements(java.util.List<org.molgenis.omx.ngs.Flowcell> entities, java.io.File baseDir) throws java.io.IOException
	{
		return false;
	}}
